1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16OPTIONS_SPEC=
17SUBDIRECTORY_OK=Yes
18. git-sh-setup
19. git-sh-i18n
20. git-parse-remote
21require_work_tree
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
24
25command=
26branch=
27force=
28reference=
29cached=
30recursive=
31init=
32files=
33remote=
34nofetch=
35update=
36prefix=
37custom_name=
38depth=
39
40# The function takes at most 2 arguments. The first argument is the
41# URL that navigates to the submodule origin repo. When relative, this URL
42# is relative to the superproject origin URL repo. The second up_path
43# argument, if specified, is the relative path that navigates
44# from the submodule working tree to the superproject working tree.
45#
46# The output of the function is the origin URL of the submodule.
47#
48# The output will either be an absolute URL or filesystem path (if the
49# superproject origin URL is an absolute URL or filesystem path,
50# respectively) or a relative file system path (if the superproject
51# origin URL is a relative file system path).
52#
53# When the output is a relative file system path, the path is either
54# relative to the submodule working tree, if up_path is specified, or to
55# the superproject working tree otherwise.
56resolve_relative_url ()
57{
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
61 url="$1"
62 remoteurl=${remoteurl%/}
63 sep=/
64 up_path="$2"
65
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
69 ;;
70 ./*|../*)
71 is_relative=t
72 ;;
73 *)
74 is_relative=t
75 remoteurl="./$remoteurl"
76 ;;
77 esac
78
79 while test -n "$url"
80 do
81 case "$url" in
82 ../*)
83 url="${url#../}"
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
87 ;;
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
91 ;;
92 *)
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
98 fi
99 ;;
100 esac
101 ;;
102 ./*)
103 url="${url#./}"
104 ;;
105 *)
106 break;;
107 esac
108 done
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
111}
112
113# Resolve a path to be relative to another path. This is intended for
114# converting submodule paths when git-submodule is run in a subdirectory
115# and only handles paths where the directory separator is '/'.
116#
117# The output is the first argument as a path relative to the second argument,
118# which defaults to $wt_prefix if it is omitted.
119relative_path ()
120{
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
126
127 while test -n "$curdir"
128 do
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
133 ;;
134 esac
135
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
142 fi
143 done
144
145 echo "$result$target"
146}
147
148#
149# Get submodule info for registered submodules
150# $@ = path to limit submodule list
151#
152module_list()
153{
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
155 (
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
158 ) |
159 @@PERL@@ -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
162 my @out = ();
163 my $unmatched = 0;
164 $/ = "\0";
165 while (<STDIN>) {
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
169 }
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
177 }
178 next;
179 }
180 push @out, "$_\n";
181 }
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
186 }
187 '
188}
189
190die_if_unmatched ()
191{
192 if test "$1" = "#unmatched"
193 then
194 exit 1
195 fi
196}
197
198#
199# Print a submodule configuration setting
200#
201# $1 = submodule name
202# $2 = option name
203# $3 = default value
204#
205# Checks in the usual git-config places first (for overrides),
206# otherwise it falls back on .gitmodules. This allows you to
207# distribute project-wide defaults in .gitmodules, while still
208# customizing individual repositories if necessary. If the option is
209# not in .gitmodules either, print a default value.
210#
211get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
219 fi
220 printf '%s' "${value:-$default}"
221}
222
223
224#
225# Map submodule path to submodule name
226#
227# $1 = path
228#
229module_name()
230{
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232 sm_path="$1"
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236 test -z "$name" &&
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 echo "$name"
239}
240
241#
242# Clone a submodule
243#
244# Prior to calling, cmd_update checks that a possibly existing
245# path is not a git repository.
246# Likewise, cmd_add checks that path does not exist at all,
247# since it is the location of a new submodule.
248#
249module_clone()
250{
251 sm_path=$1
252 name=$2
253 url=$3
254 reference="$4"
255 depth="$5"
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
260 fi
261
262 gitdir=
263 gitdir_base=
264 base_name=$(dirname "$name")
265
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
269
270 if test -d "$gitdir"
271 then
272 mkdir -p "$sm_path"
273 rm -f "$gitdir/index"
274 else
275 mkdir -p "$gitdir_base"
276 (
277 clear_local_git_env
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
282 fi
283
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
294 fi
295 while test "${a%%/*}" = "${b%%/*}"
296 do
297 a=${a#*/}
298 b=${b#*/}
299 done
300 # Now chop off the trailing '/'s that were added in the beginning
301 a=${a%/}
302 b=${b%/}
303
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
306 echo "gitdir: $rel/$a" >"$sm_path/.git"
307
308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
310}
311
312isnumber()
313{
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315}
316
317#
318# Add a new submodule to the working tree, .gitmodules and the index
319#
320# $@ = repo path
321#
322# optional branch is stored in global branch variable
323#
324cmd_add()
325{
326 # parse $args after "submodule ... add".
327 reference_path=
328 while test $# -ne 0
329 do
330 case "$1" in
331 -b | --branch)
332 case "$2" in '') usage ;; esac
333 branch=$2
334 shift
335 ;;
336 -f | --force)
337 force=$1
338 ;;
339 -q|--quiet)
340 GIT_QUIET=1
341 ;;
342 --reference)
343 case "$2" in '') usage ;; esac
344 reference_path=$2
345 shift
346 ;;
347 --reference=*)
348 reference_path="${1#--reference=}"
349 ;;
350 --name)
351 case "$2" in '') usage ;; esac
352 custom_name=$2
353 shift
354 ;;
355 --depth)
356 case "$2" in '') usage ;; esac
357 depth="--depth=$2"
358 shift
359 ;;
360 --depth=*)
361 depth=$1
362 ;;
363 --)
364 shift
365 break
366 ;;
367 -*)
368 usage
369 ;;
370 *)
371 break
372 ;;
373 esac
374 shift
375 done
376
377 if test -n "$reference_path"
378 then
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
381
382 reference="--reference=$reference_path"
383 fi
384
385 repo=$1
386 sm_path=$2
387
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
391 fi
392
393 if test -z "$repo" -o -z "$sm_path"; then
394 usage
395 fi
396
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
398
399 # assure repo is absolute or relative to parent
400 case "$repo" in
401 ./*|../*)
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
404
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
407 ;;
408 *:*|/*)
409 # absolute url
410 realrepo=$repo
411 ;;
412 *)
413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
414 ;;
415 esac
416
417 # normalize path:
418 # multiple //; leading ./; /./; /../; trailing /
419 sm_path=$(printf '%s/\n' "$sm_path" |
420 sed -e '
421 s|//*|/|g
422 s|^\(\./\)*||
423 s|/\./|/|g
424 :start
425 s|\([^/]*\)/\.\./||
426 tstart
427 s|/*$||
428 ')
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
431
432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
433 then
434 eval_gettextln "The following path is ignored by one of your .gitignore files:
435\$sm_path
436Use -f if you really want to add it." >&2
437 exit 1
438 fi
439
440 if test -n "$custom_name"
441 then
442 sm_name="$custom_name"
443 else
444 sm_name="$sm_path"
445 fi
446
447 # perhaps the path exists and is already a git repo, else clone it
448 if test -e "$sm_path"
449 then
450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
451 then
452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
453 else
454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
455 fi
456
457 else
458 if test -d ".git/modules/$sm_name"
459 then
460 if test -z "$force"
461 then
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468 else
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
470 fi
471 fi
472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
473 (
474 clear_local_git_env
475 cd "$sm_path" &&
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
477 case "$branch" in
478 '') git checkout -f -q ;;
479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
480 esac
481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
482 fi
483 git config submodule."$sm_name".url "$realrepo"
484
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
487
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
490 if test -n "$branch"
491 then
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493 fi &&
494 git add --force .gitmodules ||
495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
496}
497
498#
499# Execute an arbitrary command sequence in each checked out
500# submodule
501#
502# $@ = command to execute
503#
504cmd_foreach()
505{
506 # parse $args after "submodule ... foreach".
507 while test $# -ne 0
508 do
509 case "$1" in
510 -q|--quiet)
511 GIT_QUIET=1
512 ;;
513 --recursive)
514 recursive=1
515 ;;
516 -*)
517 usage
518 ;;
519 *)
520 break
521 ;;
522 esac
523 shift
524 done
525
526 toplevel=$(pwd)
527
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
530 exec 3<&0
531
532 module_list |
533 while read mode sha1 stage sm_path
534 do
535 die_if_unmatched "$mode"
536 if test -e "$sm_path"/.git
537 then
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
540 name=$(module_name "$sm_path")
541 (
542 prefix="$prefix$sm_path/"
543 clear_local_git_env
544 cd "$sm_path" &&
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
547 path=$sm_path &&
548 if test $# -eq 1
549 then
550 eval "$1"
551 else
552 "$@"
553 fi &&
554 if test -n "$recursive"
555 then
556 cmd_foreach "--recursive" "$@"
557 fi
558 ) <&3 3<&- ||
559 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
560 fi
561 done
562}
563
564#
565# Register submodules in .git/config
566#
567# $@ = requested paths (default to all)
568#
569cmd_init()
570{
571 # parse $args after "submodule ... init".
572 while test $# -ne 0
573 do
574 case "$1" in
575 -q|--quiet)
576 GIT_QUIET=1
577 ;;
578 --)
579 shift
580 break
581 ;;
582 -*)
583 usage
584 ;;
585 *)
586 break
587 ;;
588 esac
589 shift
590 done
591
592 module_list "$@" |
593 while read mode sha1 stage sm_path
594 do
595 die_if_unmatched "$mode"
596 name=$(module_name "$sm_path") || exit
597
598 displaypath=$(relative_path "$sm_path")
599
600 # Copy url setting when it is not set yet
601 if test -z "$(git config "submodule.$name.url")"
602 then
603 url=$(git config -f .gitmodules submodule."$name".url)
604 test -z "$url" &&
605 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
606
607 # Possibly a url relative to parent
608 case "$url" in
609 ./*|../*)
610 url=$(resolve_relative_url "$url") || exit
611 ;;
612 esac
613 git config submodule."$name".url "$url" ||
614 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
615
616 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
617 fi
618
619 # Copy "update" setting when it is not set yet
620 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
621 test -n "$upd" &&
622 test -z "$(git config submodule."$name".update)"
623 then
624 case "$upd" in
625 rebase | merge | none)
626 ;; # known modes of updating
627 *)
628 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
629 upd=none
630 ;;
631 esac
632 git config submodule."$name".update "$upd" ||
633 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
634 fi
635 done
636}
637
638#
639# Unregister submodules from .git/config and remove their work tree
640#
641# $@ = requested paths (use '.' to deinit all submodules)
642#
643cmd_deinit()
644{
645 # parse $args after "submodule ... deinit".
646 while test $# -ne 0
647 do
648 case "$1" in
649 -f|--force)
650 force=$1
651 ;;
652 -q|--quiet)
653 GIT_QUIET=1
654 ;;
655 --)
656 shift
657 break
658 ;;
659 -*)
660 usage
661 ;;
662 *)
663 break
664 ;;
665 esac
666 shift
667 done
668
669 if test $# = 0
670 then
671 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
672 fi
673
674 module_list "$@" |
675 while read mode sha1 stage sm_path
676 do
677 die_if_unmatched "$mode"
678 name=$(module_name "$sm_path") || exit
679
680 displaypath=$(relative_path "$sm_path")
681
682 # Remove the submodule work tree (unless the user already did it)
683 if test -d "$sm_path"
684 then
685 # Protect submodules containing a .git directory
686 if test -d "$sm_path/.git"
687 then
688 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
689 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
690 fi
691
692 if test -z "$force"
693 then
694 git rm -qn "$sm_path" ||
695 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
696 fi
697 rm -rf "$sm_path" &&
698 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
699 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
700 fi
701
702 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
703
704 # Remove the .git/config entries (unless the user already did it)
705 if test -n "$(git config --get-regexp submodule."$name\.")"
706 then
707 # Remove the whole section so we have a clean state when
708 # the user later decides to init this submodule again
709 url=$(git config submodule."$name".url)
710 git config --remove-section submodule."$name" 2>/dev/null &&
711 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
712 fi
713 done
714}
715
716#
717# Update each submodule path to correct revision, using clone and checkout as needed
718#
719# $@ = requested paths (default to all)
720#
721cmd_update()
722{
723 # parse $args after "submodule ... update".
724 orig_flags=
725 while test $# -ne 0
726 do
727 case "$1" in
728 -q|--quiet)
729 GIT_QUIET=1
730 ;;
731 -i|--init)
732 init=1
733 ;;
734 --remote)
735 remote=1
736 ;;
737 -N|--no-fetch)
738 nofetch=1
739 ;;
740 -f|--force)
741 force=$1
742 ;;
743 -r|--rebase)
744 update="rebase"
745 ;;
746 --reference)
747 case "$2" in '') usage ;; esac
748 reference="--reference=$2"
749 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
750 shift
751 ;;
752 --reference=*)
753 reference="$1"
754 ;;
755 -m|--merge)
756 update="merge"
757 ;;
758 --recursive)
759 recursive=1
760 ;;
761 --checkout)
762 update="checkout"
763 ;;
764 --depth)
765 case "$2" in '') usage ;; esac
766 depth="--depth=$2"
767 shift
768 ;;
769 --depth=*)
770 depth=$1
771 ;;
772 --)
773 shift
774 break
775 ;;
776 -*)
777 usage
778 ;;
779 *)
780 break
781 ;;
782 esac
783 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
784 shift
785 done
786
787 if test -n "$init"
788 then
789 cmd_init "--" "$@" || return
790 fi
791
792 cloned_modules=
793 module_list "$@" | {
794 err=
795 while read mode sha1 stage sm_path
796 do
797 die_if_unmatched "$mode"
798 if test "$stage" = U
799 then
800 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
801 continue
802 fi
803 name=$(module_name "$sm_path") || exit
804 url=$(git config submodule."$name".url)
805 branch=$(get_submodule_config "$name" branch master)
806 if ! test -z "$update"
807 then
808 update_module=$update
809 else
810 update_module=$(git config submodule."$name".update)
811 fi
812
813 displaypath=$(relative_path "$prefix$sm_path")
814
815 if test "$update_module" = "none"
816 then
817 echo "Skipping submodule '$displaypath'"
818 continue
819 fi
820
821 if test -z "$url"
822 then
823 # Only mention uninitialized submodules when its
824 # path have been specified
825 test "$#" != "0" &&
826 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
827Maybe you want to use 'update --init'?")"
828 continue
829 fi
830
831 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
832 then
833 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
834 cloned_modules="$cloned_modules;$name"
835 subsha1=
836 else
837 subsha1=$(clear_local_git_env; cd "$sm_path" &&
838 git rev-parse --verify HEAD) ||
839 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
840 fi
841
842 if test -n "$remote"
843 then
844 if test -z "$nofetch"
845 then
846 # Fetch remote before determining tracking $sha1
847 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
848 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
849 fi
850 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
851 sha1=$(clear_local_git_env; cd "$sm_path" &&
852 git rev-parse --verify "${remote_name}/${branch}") ||
853 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
854 fi
855
856 if test "$subsha1" != "$sha1" -o -n "$force"
857 then
858 subforce=$force
859 # If we don't already have a -f flag and the submodule has never been checked out
860 if test -z "$subsha1" -a -z "$force"
861 then
862 subforce="-f"
863 fi
864
865 if test -z "$nofetch"
866 then
867 # Run fetch only if $sha1 isn't present or it
868 # is not reachable from a ref.
869 (clear_local_git_env; cd "$sm_path" &&
870 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
871 test -z "$rev") || git-fetch)) ||
872 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
873 fi
874
875 # Is this something we just cloned?
876 case ";$cloned_modules;" in
877 *";$name;"*)
878 # then there is no local change to integrate
879 update_module= ;;
880 esac
881
882 must_die_on_failure=
883 case "$update_module" in
884 rebase)
885 command="git rebase"
886 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
887 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
888 must_die_on_failure=yes
889 ;;
890 merge)
891 command="git merge"
892 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
893 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
894 must_die_on_failure=yes
895 ;;
896 !*)
897 command="${update_module#!}"
898 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
899 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
900 must_die_on_failure=yes
901 ;;
902 *)
903 command="git checkout $subforce -q"
904 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
905 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
906 ;;
907 esac
908
909 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
910 then
911 say "$say_msg"
912 elif test -n "$must_die_on_failure"
913 then
914 die_with_status 2 "$die_msg"
915 else
916 err="${err};$die_msg"
917 continue
918 fi
919 fi
920
921 if test -n "$recursive"
922 then
923 (
924 prefix="$prefix$sm_path/"
925 clear_local_git_env
926 cd "$sm_path" &&
927 eval cmd_update "$orig_flags"
928 )
929 res=$?
930 if test $res -gt 0
931 then
932 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
933 if test $res -eq 1
934 then
935 err="${err};$die_msg"
936 continue
937 else
938 die_with_status $res "$die_msg"
939 fi
940 fi
941 fi
942 done
943
944 if test -n "$err"
945 then
946 OIFS=$IFS
947 IFS=';'
948 for e in $err
949 do
950 if test -n "$e"
951 then
952 echo >&2 "$e"
953 fi
954 done
955 IFS=$OIFS
956 exit 1
957 fi
958 }
959}
960
961set_name_rev () {
962 revname=$( (
963 clear_local_git_env
964 cd "$1" && {
965 git describe "$2" 2>/dev/null ||
966 git describe --tags "$2" 2>/dev/null ||
967 git describe --contains "$2" 2>/dev/null ||
968 git describe --all --always "$2"
969 }
970 ) )
971 test -z "$revname" || revname=" ($revname)"
972}
973#
974# Show commit summary for submodules in index or working tree
975#
976# If '--cached' is given, show summary between index and given commit,
977# or between working tree and given commit
978#
979# $@ = [commit (default 'HEAD'),] requested paths (default all)
980#
981cmd_summary() {
982 summary_limit=-1
983 for_status=
984 diff_cmd=diff-index
985
986 # parse $args after "submodule ... summary".
987 while test $# -ne 0
988 do
989 case "$1" in
990 --cached)
991 cached="$1"
992 ;;
993 --files)
994 files="$1"
995 ;;
996 --for-status)
997 for_status="$1"
998 ;;
999 -n|--summary-limit)
1000 summary_limit="$2"
1001 isnumber "$summary_limit" || usage
1002 shift
1003 ;;
1004 --summary-limit=*)
1005 summary_limit="${1#--summary-limit=}"
1006 isnumber "$summary_limit" || usage
1007 ;;
1008 --)
1009 shift
1010 break
1011 ;;
1012 -*)
1013 usage
1014 ;;
1015 *)
1016 break
1017 ;;
1018 esac
1019 shift
1020 done
1021
1022 test $summary_limit = 0 && return
1023
1024 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1025 then
1026 head=$rev
1027 test $# = 0 || shift
1028 elif test -z "$1" -o "$1" = "HEAD"
1029 then
1030 # before the first commit: compare with an empty tree
1031 head=$(git hash-object -w -t tree --stdin </dev/null)
1032 test -z "$1" || shift
1033 else
1034 head="HEAD"
1035 fi
1036
1037 if [ -n "$files" ]
1038 then
1039 test -n "$cached" &&
1040 die "$(gettext "The --cached option cannot be used with the --files option")"
1041 diff_cmd=diff-files
1042 head=
1043 fi
1044
1045 cd_to_toplevel
1046 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1047 # Get modified modules cared by user
1048 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1049 sane_egrep '^:([0-7]* )?160000' |
1050 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1051 do
1052 # Always show modules deleted or type-changed (blob<->module)
1053 test $status = D -o $status = T && echo "$sm_path" && continue
1054 # Respect the ignore setting for --for-status.
1055 if test -n "$for_status"
1056 then
1057 name=$(module_name "$sm_path")
1058 ignore_config=$(get_submodule_config "$name" ignore none)
1059 test $status != A -a $ignore_config = all && continue
1060 fi
1061 # Also show added or modified modules which are checked out
1062 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1063 echo "$sm_path"
1064 done
1065 )
1066
1067 test -z "$modules" && return
1068
1069 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1070 sane_egrep '^:([0-7]* )?160000' |
1071 cut -c2- |
1072 while read mod_src mod_dst sha1_src sha1_dst status name
1073 do
1074 if test -z "$cached" &&
1075 test $sha1_dst = 0000000000000000000000000000000000000000
1076 then
1077 case "$mod_dst" in
1078 160000)
1079 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1080 ;;
1081 100644 | 100755 | 120000)
1082 sha1_dst=$(git hash-object $name)
1083 ;;
1084 000000)
1085 ;; # removed
1086 *)
1087 # unexpected type
1088 eval_gettextln "unexpected mode \$mod_dst" >&2
1089 continue ;;
1090 esac
1091 fi
1092 missing_src=
1093 missing_dst=
1094
1095 test $mod_src = 160000 &&
1096 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1097 missing_src=t
1098
1099 test $mod_dst = 160000 &&
1100 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1101 missing_dst=t
1102
1103 display_name=$(relative_path "$name")
1104
1105 total_commits=
1106 case "$missing_src,$missing_dst" in
1107 t,)
1108 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1109 ;;
1110 ,t)
1111 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1112 ;;
1113 t,t)
1114 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1115 ;;
1116 *)
1117 errmsg=
1118 total_commits=$(
1119 if test $mod_src = 160000 -a $mod_dst = 160000
1120 then
1121 range="$sha1_src...$sha1_dst"
1122 elif test $mod_src = 160000
1123 then
1124 range=$sha1_src
1125 else
1126 range=$sha1_dst
1127 fi
1128 GIT_DIR="$name/.git" \
1129 git rev-list --first-parent $range -- | wc -l
1130 )
1131 total_commits=" ($(($total_commits + 0)))"
1132 ;;
1133 esac
1134
1135 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1136 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1137 if test $status = T
1138 then
1139 blob="$(gettext "blob")"
1140 submodule="$(gettext "submodule")"
1141 if test $mod_dst = 160000
1142 then
1143 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1144 else
1145 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1146 fi
1147 else
1148 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1149 fi
1150 if test -n "$errmsg"
1151 then
1152 # Don't give error msg for modification whose dst is not submodule
1153 # i.e. deleted or changed to blob
1154 test $mod_dst = 160000 && echo "$errmsg"
1155 else
1156 if test $mod_src = 160000 -a $mod_dst = 160000
1157 then
1158 limit=
1159 test $summary_limit -gt 0 && limit="-$summary_limit"
1160 GIT_DIR="$name/.git" \
1161 git log $limit --pretty='format: %m %s' \
1162 --first-parent $sha1_src...$sha1_dst
1163 elif test $mod_dst = 160000
1164 then
1165 GIT_DIR="$name/.git" \
1166 git log --pretty='format: > %s' -1 $sha1_dst
1167 else
1168 GIT_DIR="$name/.git" \
1169 git log --pretty='format: < %s' -1 $sha1_src
1170 fi
1171 echo
1172 fi
1173 echo
1174 done
1175}
1176#
1177# List all submodules, prefixed with:
1178# - submodule not initialized
1179# + different revision checked out
1180#
1181# If --cached was specified the revision in the index will be printed
1182# instead of the currently checked out revision.
1183#
1184# $@ = requested paths (default to all)
1185#
1186cmd_status()
1187{
1188 # parse $args after "submodule ... status".
1189 while test $# -ne 0
1190 do
1191 case "$1" in
1192 -q|--quiet)
1193 GIT_QUIET=1
1194 ;;
1195 --cached)
1196 cached=1
1197 ;;
1198 --recursive)
1199 recursive=1
1200 ;;
1201 --)
1202 shift
1203 break
1204 ;;
1205 -*)
1206 usage
1207 ;;
1208 *)
1209 break
1210 ;;
1211 esac
1212 shift
1213 done
1214
1215 module_list "$@" |
1216 while read mode sha1 stage sm_path
1217 do
1218 die_if_unmatched "$mode"
1219 name=$(module_name "$sm_path") || exit
1220 url=$(git config submodule."$name".url)
1221 displaypath=$(relative_path "$prefix$sm_path")
1222 if test "$stage" = U
1223 then
1224 say "U$sha1 $displaypath"
1225 continue
1226 fi
1227 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1228 then
1229 say "-$sha1 $displaypath"
1230 continue;
1231 fi
1232 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1233 then
1234 set_name_rev "$sm_path" "$sha1"
1235 say " $sha1 $displaypath$revname"
1236 else
1237 if test -z "$cached"
1238 then
1239 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1240 fi
1241 set_name_rev "$sm_path" "$sha1"
1242 say "+$sha1 $displaypath$revname"
1243 fi
1244
1245 if test -n "$recursive"
1246 then
1247 (
1248 prefix="$displaypath/"
1249 clear_local_git_env
1250 cd "$sm_path" &&
1251 eval cmd_status
1252 ) ||
1253 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1254 fi
1255 done
1256}
1257#
1258# Sync remote urls for submodules
1259# This makes the value for remote.$remote.url match the value
1260# specified in .gitmodules.
1261#
1262cmd_sync()
1263{
1264 while test $# -ne 0
1265 do
1266 case "$1" in
1267 -q|--quiet)
1268 GIT_QUIET=1
1269 shift
1270 ;;
1271 --recursive)
1272 recursive=1
1273 shift
1274 ;;
1275 --)
1276 shift
1277 break
1278 ;;
1279 -*)
1280 usage
1281 ;;
1282 *)
1283 break
1284 ;;
1285 esac
1286 done
1287 cd_to_toplevel
1288 module_list "$@" |
1289 while read mode sha1 stage sm_path
1290 do
1291 die_if_unmatched "$mode"
1292 name=$(module_name "$sm_path")
1293 url=$(git config -f .gitmodules --get submodule."$name".url)
1294
1295 # Possibly a url relative to parent
1296 case "$url" in
1297 ./*|../*)
1298 # rewrite foo/bar as ../.. to find path from
1299 # submodule work tree to superproject work tree
1300 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1301 # guarantee a trailing /
1302 up_path=${up_path%/}/ &&
1303 # path from submodule work tree to submodule origin repo
1304 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1305 # path from superproject work tree to submodule origin repo
1306 super_config_url=$(resolve_relative_url "$url") || exit
1307 ;;
1308 *)
1309 sub_origin_url="$url"
1310 super_config_url="$url"
1311 ;;
1312 esac
1313
1314 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1315 then
1316 displaypath=$(relative_path "$prefix$sm_path")
1317 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1318 git config submodule."$name".url "$super_config_url"
1319
1320 if test -e "$sm_path"/.git
1321 then
1322 (
1323 clear_local_git_env
1324 cd "$sm_path"
1325 remote=$(get_default_remote)
1326 git config remote."$remote".url "$sub_origin_url"
1327
1328 if test -n "$recursive"
1329 then
1330 prefix="$prefix$sm_path/"
1331 eval cmd_sync
1332 fi
1333 )
1334 fi
1335 fi
1336 done
1337}
1338
1339# This loop parses the command line arguments to find the
1340# subcommand name to dispatch. Parsing of the subcommand specific
1341# options are primarily done by the subcommand implementations.
1342# Subcommand specific options such as --branch and --cached are
1343# parsed here as well, for backward compatibility.
1344
1345while test $# != 0 && test -z "$command"
1346do
1347 case "$1" in
1348 add | foreach | init | deinit | update | status | summary | sync)
1349 command=$1
1350 ;;
1351 -q|--quiet)
1352 GIT_QUIET=1
1353 ;;
1354 -b|--branch)
1355 case "$2" in
1356 '')
1357 usage
1358 ;;
1359 esac
1360 branch="$2"; shift
1361 ;;
1362 --cached)
1363 cached="$1"
1364 ;;
1365 --)
1366 break
1367 ;;
1368 -*)
1369 usage
1370 ;;
1371 *)
1372 break
1373 ;;
1374 esac
1375 shift
1376done
1377
1378# No command word defaults to "status"
1379if test -z "$command"
1380then
1381 if test $# = 0
1382 then
1383 command=status
1384 else
1385 usage
1386 fi
1387fi
1388
1389# "-b branch" is accepted only by "add"
1390if test -n "$branch" && test "$command" != add
1391then
1392 usage
1393fi
1394
1395# "--cached" is accepted only by "status" and "summary"
1396if test -n "$cached" && test "$command" != status -a "$command" != summary
1397then
1398 usage
1399fi
1400
1401"cmd_$command" "$@"